"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.empty = void 0;
const tslib_1 = require("tslib");
const asynciterablex_js_1 = require("./asynciterablex.js");
const aborterror_js_1 = require("../aborterror.js");
class EmptyAsyncIterable extends asynciterablex_js_1.AsyncIterableX {
    [Symbol.asyncIterator](signal) {
        return tslib_1.__asyncGenerator(this, arguments, function* _a() {
            (0, aborterror_js_1.throwIfAborted)(signal);
        });
    }
}
/**
 * Returns an empty async-iterable sequence.
 *
 * @template TSource The type used for the async-iterable type parameter of the resulting sequence.
 * @returns {AsyncIterableX<never>} An async-iterable sequence with no elements.
 */
function empty() {
    return new EmptyAsyncIterable();
}
exports.empty = empty;

//# sourceMappingURL=empty.js.map
