"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGrouping = void 0;
const tslib_1 = require("tslib");
const withabort_js_1 = require("./withabort.js");
/**
 * @ignore
 */
function createGrouping(source, keySelector, elementSelector, signal) {
    var _a, e_1, _b, _c;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const map = new Map();
        try {
            for (var _d = true, _e = tslib_1.__asyncValues((0, withabort_js_1.wrapWithAbort)(source, signal)), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                _c = _f.value;
                _d = false;
                const item = _c;
                const key = yield keySelector(item, signal);
                let grouping = map.get(key);
                if (!map.has(key)) {
                    grouping = [];
                    map.set(key, grouping);
                }
                const element = yield elementSelector(item, signal);
                grouping.push(element);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return map;
    });
}
exports.createGrouping = createGrouping;

//# sourceMappingURL=_grouping.js.map
