"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.startWith = exports.StartWithAsyncIterable = void 0;
const tslib_1 = require("tslib");
const asynciterablex_js_1 = require("../asynciterablex.js");
const withabort_js_1 = require("./withabort.js");
const aborterror_js_1 = require("../../aborterror.js");
/** @ignore */
class StartWithAsyncIterable extends asynciterablex_js_1.AsyncIterableX {
    constructor(source, args) {
        super();
        this._source = source;
        this._args = args;
    }
    [Symbol.asyncIterator](signal) {
        return tslib_1.__asyncGenerator(this, arguments, function* _a() {
            var _b, e_1, _c, _d;
            (0, aborterror_js_1.throwIfAborted)(signal);
            for (const x of this._args) {
                yield yield tslib_1.__await(x);
            }
            try {
                for (var _e = true, _f = tslib_1.__asyncValues((0, withabort_js_1.wrapWithAbort)(this._source, signal)), _g; _g = yield tslib_1.__await(_f.next()), _b = _g.done, !_b; _e = true) {
                    _d = _g.value;
                    _e = false;
                    const item = _d;
                    yield yield tslib_1.__await(item);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_e && !_b && (_c = _f.return)) yield tslib_1.__await(_c.call(_f));
                }
                finally { if (e_1) throw e_1.error; }
            }
        });
    }
}
exports.StartWithAsyncIterable = StartWithAsyncIterable;
/**
 * Prepend a value to an async-iterable sequence.
 *
 * @template TSource The type of the elements in the source sequence.
 * @param {...TSource[]} args Elements to prepend to the specified sequence.
 * @returns The source sequence prepended with the specified values.
 */
function startWith(...args) {
    return function startWithOperatorFunction(source) {
        return new StartWithAsyncIterable(source, args);
    };
}
exports.startWith = startWith;

//# sourceMappingURL=startwith.js.map
