"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeLast = exports.TakeLastAsyncIterable = void 0;
const tslib_1 = require("tslib");
const asynciterablex_js_1 = require("../asynciterablex.js");
const withabort_js_1 = require("./withabort.js");
const aborterror_js_1 = require("../../aborterror.js");
/** @ignore */
class TakeLastAsyncIterable extends asynciterablex_js_1.AsyncIterableX {
    constructor(source, count) {
        super();
        this._source = source;
        this._count = count;
    }
    [Symbol.asyncIterator](signal) {
        return tslib_1.__asyncGenerator(this, arguments, function* _a() {
            var _b, e_1, _c, _d;
            (0, aborterror_js_1.throwIfAborted)(signal);
            if (this._count > 0) {
                const q = [];
                try {
                    for (var _e = true, _f = tslib_1.__asyncValues((0, withabort_js_1.wrapWithAbort)(this._source, signal)), _g; _g = yield tslib_1.__await(_f.next()), _b = _g.done, !_b; _e = true) {
                        _d = _g.value;
                        _e = false;
                        const item = _d;
                        if (q.length >= this._count) {
                            q.shift();
                        }
                        q.push(item);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (!_e && !_b && (_c = _f.return)) yield tslib_1.__await(_c.call(_f));
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                while (q.length > 0) {
                    yield yield tslib_1.__await(q.shift());
                }
            }
        });
    }
}
exports.TakeLastAsyncIterable = TakeLastAsyncIterable;
/**
 * Returns a specified number of contiguous elements from the end of an async-iterable sequence.
 *
 * @template TSource The type of the elements in the source sequence.
 * @param {number} count Number of elements to take from the end of the source sequence.
 * @returns {MonoTypeOperatorAsyncFunction<TSource>} An async-iterable sequence containing the specified
 * number of elements from the end of the source sequence.
 */
function takeLast(count) {
    return function takeLastOperatorFunction(source) {
        return new TakeLastAsyncIterable(source, count);
    };
}
exports.takeLast = takeLast;

//# sourceMappingURL=takelast.js.map
